<?php
/**
 * @copyright	Copyright (C) 2010 Michael Richey. All rights reserved.
 * @license		GNU General Public License version 3; see LICENSE.txt
 */

defined('JPATH_BASE') or die;

jimport('joomla.form.formfield');

class JFormFieldLog extends JFormField
{
	protected function getLabel() {
            return '';
        }
	protected function getInput()
	{
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('*')->from('#__plg_system_loggie')->order('ts ASC');
            $db->setQuery($query);
            $logs = $db->loadObjectList();
            if(!count($logs)) return JText::_('PLG_SYS_LOGGIE_NO_LOGS');
            JHTML::_('behavior.framework',true);
            JFactory::getDocument()->addScript(JURI::root(true).'/media/plg_system_loggie/admin.js');
            $etrans=array(
                2=>"E_WARNING",
                8=>"E_NOTICE",
                256=>"E_USER_ERROR",
                512=>"E_USER_WARNING",
                1024=>"E_USER_NOTICE",
                4096=>"E_RECOVERABLE_ERROR",
                8191=>"E_ALL"
            );
            $return = array('<span id="nologgielogs">'.JText::_('PLG_SYS_LOGGIE_NO_LOGS').'</span>');
            $return[]='<button id="clearloggie" class="loggietable">'.JText::_('PLG_SYS_LOGGIE_CLEAR_LOGGIE').'</button>';
            $return[]='<table id="loggietable" class="table table-striped table-condensed loggietable"><tr><th>'.JText::_('PLG_SYS_LOGGIE_TS').'</th><th>'.JText::_('PLG_SYS_LOGGIE_LOG').'</th></tr>';
            foreach($logs as $log) {
                $return[]='<tr>';
                    $return[]='<td style="vertical-align:top">'.$log->ts.'</td>';
                    $return[]='<td>'.JText::_('PLG_SYS_LOGGIE_'.$etrans[$log->errno]).': '.$log->errstr.'<br /><span class="small">'.$log->errfile.' on line '.$log->errline.'</span></td>';
                $return[]='</tr>';
            }
            $return[]='</table>';
            return implode("\n",$return);
        }
}
