<?php

/**
 * @package plugin Loggie
 * @copyright (C) 2010-2013 Michael Richey
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemLoggie extends JPlugin {
    private $db;
    private $error_handler;
    public function onAfterInitialise() {
        $this->db = JFactory::getDbo();
        $app = JFactory::getApplication();
        JFactory::getLanguage()->load('plg_system_loggie',JPATH_ADMINISTRATOR);
        $app->enqueueMessage(JText::_('PLG_SYS_LOGGIE_ENABLED'),'notice');
        $this->error_handler = set_error_handler(array($this,'_loggieErrorHandler'));
        if($app->isAdmin()) {
            if($app->input->get->get('clearloggie',false)) {
                $this->_loggieClear();
            }
        }
        return true;
    }
    public function _loggieErrorHandler() {
        $args = func_get_args();
        $columns=array();
        $values=array();
        $query = $this->db->getQuery(true);
        foreach(array('errno','errstr','errfile','errline') as $key=>$erritem) {
            $columns[]=$this->db->quoteName($erritem);
            $values[]=($erritem=='errno')?$args[$key]:$this->db->quote($args[$key]);
        }
        $query->insert('#__plg_system_loggie')->columns($columns)->values(implode(',',$values));
        $this->db->setQuery($query);
        $this->db->execute();
    }
    public function _loggieClear() {
        $query = $this->db->getQuery(true);
        $query->select('*')->from('#__plg_system_loggie')->order('ts ASC');
        $this->db->setQuery($query);
        $logs = $this->db->loadAssocList();
        set_error_handler($this->error_handler);
        foreach($logs as $log) error_log('Loggie throwback: '.implode(',',$log));
        set_error_handler(array($this,'_loggieErrorHandler'));
        $this->db->setQuery('DELETE FROM #__plg_system_loggie');
        $this->db->execute();
        header('Content-Type: application/json');
        die(json_encode(array('success' => true)));
    }
}